package com.stl.flutter_ali_oauth.event;


import com.google.gson.Gson;
import com.stl.flutter_ali_oauth.bean.ViewMessageResult;

import io.flutter.plugin.common.BinaryMessenger;
import io.flutter.plugin.common.EventChannel;

/**
 * @author Ricky
 * @date 2020/10/22
 * View回调推送
 */
public class ViewEvent implements IMessageEvent<ViewMessageResult> {

    private static ViewEvent instance;
    private EventChannel.EventSink eventSink;

    public static ViewEvent getInstance() {
        if (instance == null) {
            instance = new ViewEvent();
        }
        return instance;
    }

    private ViewEvent() {
    }

    private EventChannel eventChannel;

    private String EVENT_CHANNEL = "com.stl/viewEvent";

    @Override
    public void initEventChannel(BinaryMessenger messenger) {
        eventChannel = new EventChannel(messenger, EVENT_CHANNEL);
        eventChannel.setStreamHandler(new EventChannel.StreamHandler() {
            @Override
            public void onListen(Object arguments, EventChannel.EventSink events) {
                eventSink = events;
            }

            @Override
            public void onCancel(Object o) {

            }
        });
    }

    @Override
    public void sendSuccess(ViewMessageResult viewPositionResult) {
        if (eventSink != null) {
            String viewMessage = new Gson().toJson(viewPositionResult);
            eventSink.success(viewMessage);
        }
    }

    @Override
    public void sendError(ViewMessageResult viewPositionResult) {

    }


}
